;***************************************************************************
; Testovac program pro PVK V1.1    (c) ASIX s.r.o. 1995
; 25. jna 1995.
; PIC16C84-04/P, Osc: XT, WDT: Off, Put: On, CP: On, CkSum: b8ce.
; Obsahuje hodiny s autorepeatem a testovac sekvenci pro jednotliv segmen-
; ty slicovek (vetn desetinnch teek) a pro diody D1 a D8.
;***************************************************************************
       list   p=16c84
;       __config        3fe9h                   ; pojistky
; frekvence vnjho osciltoru je 3.2768MHz => instrukn cyklus = 1.22s
; kdy to vynsobme 256 (rtcc) a 16 (peddli), dostaneme pesn 5ms
;***************************************************************************
; Zapojen pin
;   RA0 buzen anody tvrt slice zleva (DISP0)                  (out)
;   RA1 buzen anody tet  slice zleva (DISP1)                  (out)
;   RA2 buzen anody druh  slice zleva (DISP2)                  (out)
;   RA3 buzen anody prvn  slice zleva (DISP3)                  (out)
;   RB0 a RB7 jednotliv segmenty slic, pouv se v multiplexu (out)
;   RB0 spolen rove pro tlatka                               (out)
;   RB1 tlatko 1 - start / stop                                  (in)
;   RB2 tlatko 2 - pepnn zobrazovn                         (in)
;   RB3 tlatko 3 - nastaven hodin                               (in)
;   RB4 tlatko 4 - nastaven minut                               (in)
;   RB5 tlatko 5 - skok do testovac sekvence z reimu hodin     (in)
;   RB6 tlatko 6 - pepnn segment slicovek a diod D1 a D8 (in)
;   RB7 tlatko 7 - ukonen testovac sekvence, nvrat k hodinm (in)
;***************************************************************************
ind     equ     00h     ; registr f0
rtcc    equ     01h     ; samovysvtlujc
pc      equ     02h     ; samovysvtlujc
stat    equ     03h     ; samovysvtlujc
fsr     equ     04h     ; samovysvtlujc
porta   equ     05h     ; samovysvtlujc
portb   equ     06h     ; samovysvtlujc
portc   equ     07h     ; neimplementovno, pouze pro peklad

hod     equ     10h     ; registr na uloen hodin v BCD kdu
min     equ     11h     ; registr na uloen minut v BCD kdu
sec     equ     12h     ; registr na uloen vtein v BCD kdu
                        ; mus bt za sebou v tomto poad

citac   equ     13h     ; ta 1 vteiny
konec   equ     14h     ; registr pro uloen konen hodnoty pi aktualizaci
stav1   equ     15h     ; stav systmu
                        ; bit0: 0 tlatk0 nestisknuto (poten stav)
                        ;       1 tlatko uznno za stisknut a stle dreno
                        ; bit1: 0 hodiny b (poten stav)
                        ;       1 hodiny stoj
                        ; bit2: 0 zobrazujeme hodiny a minuty (poten stav)
                        ;       1 zobrazujeme minuty a vteiny
                        ; bit3: 0 hodiny bez autorepeatu (poten stav)
                        ;       1 hodiny s autorepeatem
                        ; bit4: 0 minuty bez autorepeatu (poten stav)
                        ;       1 minuty s autorepeatem
                        ; bit5: 0 diody a segmenty bez autorepeatu
                        ;         (poten stav)
                        ;       1 diody a segmenty s autorepeatem
                        ; bit6: 0 reim relnho asu (poten stav)
                        ;       1 testovac reim
                        ; bit7: 0 zmna registru anody zakzna
                        ;         (poten stav)
                        ;       1 zmna registru anody povolena
cit_m   equ     16h     ; ta multiplexu, t 0,1,2,3,0,1,2,3,0,1,...
digit   equ     17h     ; registr pro zobrazovanou slici
new     equ     18h     ; registr na uloen stavu tlatek - nov hodnoty
old     equ     19h     ; registr na uloen stavu tlatek - star hodnoty
cit_p   equ     1ah     ; ta prodlevy
cit_a   equ     1bh     ; ta autorepeatu
diody   equ     1ch     ; registr pro uloen kdu segment displeje nebo
                        ; pro kd diod D1 a D8
anody   equ     1dh     ; registr na uloen hodnot pro buzen anod AN1 a
                        ; AN4 nebo pro aktivaci pinu C0

w       equ     00h     ; samovysvtlujc
f       equ     01h     ; samovysvtlujc
carry   equ     00h     ; bit 0 stavovho slova
dcarry  equ     01h     ; bit 1 stavovho slova
nula    equ     02h     ; bit 2 stavovho slova
push    equ     00h     ; bit 0 registru stav1
stop    equ     01h     ; bit 1 registru stav1
hm      equ     02h     ; bit 2 registru stav1
ah      equ     03h     ; bit 3 registru stav1 (autorepeat hodin)
am      equ     04h     ; bit 4 registru stav1 (autorepeat minut)
ad      equ     05h     ; bit 5 registru stav1 (autorepeat diod a segment)
test    equ     06h     ; bit 6 registru stav1 (testovac reim)
zmena   equ     07h     ; bit 7 registru stav1 (povolen/zakzn zmny)
dp      equ     07h     ; bit 7 portu B (desetinn teka)

        org     00h     ; tady zan PIC po resetu
;***************************************************************************
        goto    init    ; skok na zatek programu
;***************************************************************************
; Rutina kduje BCD slice na kd pro sedmisegmentov displej. Vstup i vs-
; tup se dje pes registr w, vstup je slice BCD, vstupem je pak obsah
; registru w, kter posln na port B rozsvt pslunou slici. Segment
; svt, je-li pslun bit portu B v nule.
tab1    addwf   pc, f           ; vbr slice
        retlw   b'11000000'     ; 0 - zobraz 0
        retlw   b'11111001'     ; 1 - zobraz 1
        retlw   b'10100100'     ; 2 - zobraz 2
        retlw   b'10110000'     ; 3 - zobraz 3
        retlw   b'10011001'     ; 4 - zobraz 4
        retlw   b'10010010'     ; 5 - zobraz 5
        retlw   b'10000010'     ; 6 - zobraz 6
        retlw   b'11111000'     ; 7 - zobraz 7
        retlw   b'10000000'     ; 8 - zobraz 8
        retlw   b'10010000'     ; 9 - zobraz 9
;***************************************************************************
; Rutina kduje podle cit_m jednu anodu, kter bude aktivn. Vstup i vstup
; je opt pes registr w, vstup se tentokrt posl na port A. Anoda je
; aktivovna, je-li pslun bit portu A v nule.
tab2    addwf   pc, f           ; vbr anody
        retlw   b'11110111'     ; cit_m=0 - aktivuje anodu 3
        retlw   b'11111011'     ; cit_m=1 - aktivuje anodu 2
        retlw   b'11111101'     ; cit_m=2 - aktivuje anodu 1
        retlw   b'11111110'     ; cit_m=3 - aktivuje anodu 0
;***************************************************************************
; Aktualizan rutina, vstup je adresa registru, jen se m aktualizovat
; (uloen ped volnm do fsr) a hodnota pro peteen (registr konec).
; Rutina pite jedniku s BCD korekc k registru, na kter ukazuje fsr.
; Jestlie se tento registr po piten jedniky rovn registru konec,
; rutina tento registr nuluje a nastavuje Z=1.
aktual  movlw   .7
        addwf   ind, f          ; pite do ind 1 s BCD korekc
        btfsc   stat, dcarry
        goto    akt_a
        movlw   .6
        subwf   ind, f
akt_a   movf    konec, w
        xorwf   ind, w
        btfsc   stat, nula      ; ind = konec? (Z=1?)
        clrf    ind             ; ano => nulovan ind
        retlw   00h             ; ne  => konec
;***************************************************************************
; Rutina zajist ekn 5ms (ne od okamiku voln rutiny, ale od poslednho
; peteen rtcc).
_5ms    comf    rtcc, w
        btfss   stat, nula      ; rtcc = 0ffh? (Z=1?)
        goto    _5ms            ; ne  => ekme
                                ; ano => testujeme peteen
_5ms_a  btfsc   rtcc, 0         ; rtcc petekl? (bit0=0?)
        goto    _5ms_a          ; ne  => ekme na peteen
        retlw   00h             ; ano => konec
;***************************************************************************
; Rutina rozsvt na 5ms jednu slici ze ty monch. Vbr slice se
; provd jednak na zklad bitu hm registru stav1 a jednak na zklad
; hodnoty tae multiplexu cit_m.
zobraz  movlw   0ffh
        movwf   porta           ; odpojen anod displeje
        movlw   hod
        movwf   fsr             ; adresa registru hod do fsr
        btfsc   stav1, hm       ; zobrazujeme hod a min? (bit=0?)
        incf    fsr, f          ; ne  => v fsr je adresa min
                                ; ano => nic se nedje
        bcf     stat, carry     ; nulovn carry pro rotaci
        rrf     cit_m, w        ; ta multiplexu dlen dvma je ve w
                                ; v carry je 1, byl-li cit_m lich,
                                ;            0, byl-li cit_m sud
        iorlw   00h             ; nastavuje bit nula stavovho slova
                                ; nutn - instrukce rrf to nedl
        btfss   stat, nula      ; pvodn hodnota cit_m = 0 nebo 1? (Z=1?)
        incf    fsr, f          ; ne  => fsr ukazuje na nsledujc registr:
                                ;        sec, jsme-li v reimu min, sec
                                ;        min, jsme-li v reimu hod, min
                                ; ano => nic se nedje
        movf    ind, w          ; vybran registr do w
        movwf   digit           ; a w do digit
        btfss   stat, carry     ; cit_m byl lich? (C=1?)
        swapf   digit, f        ; ne  => prohodme tveice
                                ; ano => beze zmny
        movlw   b'00001111'
        andwf   digit, w        ; zamaskovn, vsledkem je jedna BCD slice
        call    tab1            ; pekdovn BCD slice na segmenty
        movwf   portb           ; kdy segment na port B
        movf    cit_m, w        ; cit_m do w
        call    tab2            ; podle cit_m dekdujeme jednu anodu
        movwf   porta           ; aktivace pslun anody
        bcf     stat, carry     ; nulovn carry pro rotaci
        rrf     sec, w          ; vteiny dlen dvma do w
        btfsc   stat, carry     ; zobrazuji sudou vteinu? (C=0?)
        goto    zobr_a          ; ne  => dvojteka zhasnuta
                                ; ano => rozsvtme jednu z diod DP2 nebo DP1,
                                ;        vzhledem k multiplexu pak vidme
                                ;        vodorovnou "dvojteku"
        movf    cit_m, w
        xorlw   01h
        btfsc   stat, nula      ; cit_m = 1? (Z=1?)
        bcf     portb, dp       ; ano => rozsvtm diodu DP2
                                ; ne  => nic se nedje
        movf    cit_m, w
        xorlw   02h
        btfsc   stat, nula      ; cit_m = 2? (Z=1?)
        bcf     portb, dp       ; ano => rozsvtm diodu DP1
                                ; ne  => nic se nedje
zobr_a  incf    cit_m, f        ; inkrementujeme cit_m
        movlw   b'00000011'
        andwf   cit_m, f        ; zamaskovn, cit_m te t jen do 3
        retlw   00h             ; konec
;***************************************************************************
; Rutina zajist oeten zkmit pi ten tlatek a zrove zajist na-
; staven pslunch bit registru stav1, ktermi se d stav systmu.
; Rutina te tlatka kadch 20ms (vyuvn registr cit_m), a je-li tla-
; tko dreno alespo dvakrt za sebou, uzn se stisknut za platn.
tlacit  movf    cit_m, w
        btfss   stat, nula      ; cit_m = 0? (Z=1?)
        retlw   00h             ; ne  => konec
        movlw   b'11111111'     ; ano => ten stavu tlatek
        movwf   porta           ; odpojen anod displeje
        clrf    portb           ; nulovn mimo jin bitu 0 portu B (spolen
        movlw   b'11111110'     ; rove pro tlatka)
        tris    portb           ; RB0 vstup, ostatn vstupy
        movlw   .56
        movwf   cit_p           ; ta prodlevy = 56
tlac_a  decfsz  cit_p, f        ; prodleva na ustlen stavu na sbrnici
        goto    tlac_a          ; asi 200s
        movf    portb, w        ; ten portu B (stav tlatek)
                                ; tlatko stisknuto => na pinu je 0
        xorlw   b'11111111'     ; negace stavu tlatek
        andlw   b'00111110'     ; zamaskovn nepotebnch bit
                                ; tlatko stisknuto => bit registru je 1
        movwf   new             ; pepis stavu tlatek do registru new
        clrf    portb           ; nulovn portu B ped pepnutm smru
        movlw   00h
        tris    portb           ; port B opt jako vstup
        btfss   stav1, push     ; tlatko stle dreno? (bit push=1?)
        goto    tlac_d          ; ne  => dal zpracovn
                                ; ano => test, zda-li bylo putno
        clrf    old             ; nulovn old
        movf    new, w
        btfss   stat, nula      ; new = 0? (Z=1?)
        goto    tlac_b          ; ne  => testujeme autorepeat
        bcf     stav1, push     ; ano => tlatko putno, bit shozen
        bcf     stav1, ah       ; u nebude autorepeat hodin
        bcf     stav1, am       ; ani autorepeat minut
        retlw   00h             ; konec

tlac_b  decfsz  cit_a, f        ; ta autorepeatu vypel?
        retlw   00h             ; ne  => konec
        movlw   .12             ; ano => nastaven prodlevy mezi opakovnm
        movwf   cit_a           ; na 12*20ms = 240ms

        btfss   stav1, ah       ; autorepeat hodin? (bit ah=1?)
        goto    tlac_c          ; ne  => test autorepeatu minut
        movlw   hod             ; ano => inkrementujeme hodiny
        movwf   fsr
        movlw   24h
        movwf   konec           ; vbr hodin
        call    aktual          ; aktualizace hodin
        retlw   00h             ; a konec

tlac_c  btfss   stav1, am       ; autorepeat minut? (bit am=1?)
        retlw   00h             ; ne  => konec
        movlw   min             ; inkrementujeme minuty
        movwf   fsr
        movlw   60h
        movwf   konec           ; vbr minut
        call    aktual          ; aktualizace minut
        retlw   00h             ; a konec

tlac_d  movf    old, w          ; star stav tlatek do w
        andwf   new, w          ; ve w je new and old
        btfss   stat, nula      ; new and old = 0? (Z=1?)
        goto    tlac_e          ; ne  => tlatko stisknuto
        movf    new, w          ; ano => pepis novho stavu do starho
        movwf   old
        retlw   00h             ; a konec

tlac_e  bsf     stav1, push     ; tlatko dreno, nastaven bitu
        movlw   .50
        movwf   cit_a           ; prodleva ped autorepeatem 50*20ms = 1000ms

        btfss   new, 1          ; stisknuto tlatko start/stop? (bit1=1?)
        goto    tlac_f          ; ne  => dal testovn
        movlw   b'00000010'     ; ano => negace bitu stop, ostatn beze zmn
        xorwf   stav1, f
        btfsc   stav1, stop     ; hodiny stoj? (bit stop=1?)
        clrf    sec             ; ano => nulovn vtein a konec
        retlw   00h             ; ne  => pouze konec

tlac_f  btfss   new, 2          ; stisknuto tlatko pepnn? (bit2=1?)
        goto    tlac_g          ; ne  => dal testovn
        movlw   b'00000100'     ; ano => negace bitu hm, ostatn beze zmn
        xorwf   stav1, f
        retlw   00h             ; a konec

tlac_g  btfss   new, 3          ; stisknuto tlatko nastaven hod? (bit3=1?)
        goto    tlac_h          ; ne  => dal testovn
        movlw   hod             ; ano => inkrementujeme hodiny
        movwf   fsr
        movlw   24h
        movwf   konec           ; vbr hodin
        call    aktual          ; aktualizace hodin
        bsf     stav1, ah       ; bude autorepeat hodin
        retlw   00h             ; a konec

tlac_h  btfss   new, 4          ; stisknuto tlatko nastaven min? (bit4=1?)
        goto    tlac_i          ; ne  => vstup do testovac sekvence
        movlw   min             ; ano => inkrementujeme minuty
        movwf   fsr
        movlw   60h
        movwf   konec           ; vbr minut
        call    aktual          ; aktualizace minut
        bsf     stav1, am       ; bude autorepeat minut
        retlw   00h             ; a konec

tlac_i  bsf     stav1, test     ; testovac reim
        retlw   00h             ; konec
;***************************************************************************
; Rutina zajist oeten zkmit pi ten tlatek v testovacm reimu
; Rutina te tlatka kadch 20ms (vyuvn registr cit_m), a je-li tla-
; tko dreno alespo dvakrt za sebou, uzn se stisknut za platn.
tltest  movf    cit_m, w
        btfss   stat, nula      ; cit_m = 0? (Z=1?)
        retlw   00h             ; ne  => konec
                                ; ano => ten stavu tlatek
;        bcf     portc, 0        ; odpojen anod diod D1 a D8
        movlw   b'11111111'
        movwf   porta           ; odpojen anod displeje
        clrf    portb           ; nulovn mimo jin bitu 0 portu B (spolen
        movlw   b'11111110'     ; rove pro tlatka)
        tris    portb           ; RB0 vstup, ostatn vstupy
        movlw   .56
        movwf   cit_p           ; ta prodlevy = 56
tlte_a  decfsz  cit_p, f        ; prodleva na ustlen stavu na sbrnici
        goto    tlte_a          ; asi 200s
        movf    portb, w        ; ten portu B (stav tlatek)
                                ; tlatko stisknuto => na pinu je 0
        xorlw   b'11111111'     ; negace stavu tlatek
        andlw   b'11000000'     ; zamaskovn nepotebnch bit
                                ; tlatko stisknuto => bit registru je 1
        movwf   new             ; pepis stavu tlatek do registru new
        clrf    portb           ; nulovn portu B ped pepnutm smru
        movlw   00h
        tris    portb           ; port B opt jako vstup
        btfss   stav1, push     ; tlatko stle dreno? (bit push=1?)
        goto    tlte_c          ; ne  => dal zpracovn
                                ; ano => test, zda-li bylo putno
        clrf    old             ; nulovn old
        movf    new, w
        btfss   stat, nula      ; new = 0? (Z=1?)
        goto    tlte_b          ; ne  => testujeme autorepeat
        bcf     stav1, push     ; ano => tlatko putno, bit shozen
        bcf     stav1, ad       ; u nebude autorepeat diod a segment
        retlw   00h             ; konec

tlte_b  decfsz  cit_a, f        ; ta autorepeatu vypel?
        retlw   00h             ; ne  => konec
        movlw   .10             ; ano => nastaven prodlevy mezi opakovnm
        movwf   cit_a           ; na 10*20ms = 200ms

        btfss   stav1, ad       ; autorepeat diod a segment? (bit ad=1?)
        retlw   00h             ; ne  => konec
        movlw   0ffh            ; ano => rozsvtme dal diodu nebo segment
        xorwf   diody, w
        bcf     stat, carry     ; nulovn carry pro rotaci pedem
        btfss   stat, nula      ; diody = 0ffh (Z=1?)
        bsf     stat, carry     ; ne  => carry = 1
                                ; ano => carry = 0 (odminula)
        btfss   stat, nula      ; diody = 0ffh (Z=1?)
        bsf     stav1, zmena    ; ne  => zmna povolena
                                ; ano => bit nezmnn
        rlf     diody, f        ; vbr dal diody nebo segmentu
        retlw   00h             ; a konec

tlte_c  movf    old, w          ; star stav tlatek do w
        andwf   new, w          ; ve w je new and old
        btfss   stat, nula      ; new and old = 0? (Z=1?)
        goto    tlte_d          ; ne  => tlatko stisknuto
        movf    new, w          ; ano => pepis novho stavu do starho
        movwf   old
        retlw   00h             ; a konec

tlte_d  bsf     stav1, push     ; tlatko dreno, nastaven bitu
        movlw   .50
        movwf   cit_a           ; prodleva ped autorepeatem 50*20ms = 1000ms

        btfss   new, 6          ; stisknuto tlatko pepnn? (bit6=1?)
        goto    tlte_e          ; ne  => stisknuto tlatko konec test
        movlw   0ffh            ; ano => rozsvtme dal diodu nebo segment
        xorwf   diody, w
        bcf     stat, carry     ; nulovn carry pro rotaci pedem
        btfss   stat, nula      ; diody = 0ffh (Z=1?)
        bsf     stat, carry     ; ne  => carry = 1
                                ; ano => carry = 0 (odminula)
        btfss   stat, nula      ; diody = 0ffh (Z=1?)
        bsf     stav1, zmena    ; ne  => zmna povolena
                                ; ano => bit nezmnn
        rlf     diody, f        ; vbr dal diody nebo segmentu
        bsf     stav1, ad       ; bude autorepeat diod a segment
        retlw   00h             ; a konec

tlte_e  ; clrf    portc           ; nulovn portu C
        movlw   b'11111111'     ; nastaven portu A
        movwf   porta           ; budie zaveny => nic nesvt
        clrf    portb           ; nulovn portu B
        bcf     stav1, test     ; reim relnho asu
        bcf     stav1, push     ; tlatko putno, bit shozen
        bcf     stav1, ad       ; nebude autorepeat diod a segment
        bcf     stav1, zmena    ; zmna zakzna (pro jistotu)
        clrf    cit_a           ; nulovn tae autorepeatu
        retlw   00h             ; konec
;***************************************************************************
; Inicializan rutina, nastav porty a stav systmu, vynuluje hodiny,
; minuty, vteiny a pejde do reimu relnho asu se zobrazovnm hodin
; a minut.
init

	movlw   0ffh            ; nastaven portu A
        movwf   porta           ; budie zaveny => nic nesvt
        clrf    portb           ; nulovn portu B
        movlw   b'11100000'
        tris    porta           ; port A jako vstupn (krom RA4 - vstup)
        movlw   00h
        tris    portb           ; port B jako vstupn
        movlw   b'10000011'     ; rtcc buzen intern, peddli 1:16
        option                  ; pull-up disable!!!! (mus bt)
        clrf    stav1           ; poten nastaven stavu systmu
        clrf    cit_m           ; nulovn tae multiplexu
        clrf    hod             ; nulovn hodin
        clrf    min             ; nulovn minut
        clrf    sec             ; nulovn vtein
        clrf    new             ; nulovn registru pro stav tlatek
        clrf    old             ; nulovn registru pro stav tlatek
        goto    real            ; konec, skok do reimu relnho asu
;***************************************************************************
real    movlw   .200
        movwf   citac           ; hlavn ta na 1s
real_a  decfsz  citac, f        ; uplynula 1s?
        goto    real_b          ; ne  => jdeme dle
        movlw   .200
        movwf   citac           ; ano => znovunastaven tae
        btfsc   stav1, stop     ; hodiny b? (bit stop=0?)
        goto    real_b          ; ne  => jdeme dle
        movlw   sec             ; ano => aktualizujeme as
        movwf   fsr
        movlw   60h
        movwf   konec           ; vbr vtein
        call    aktual          ; aktualizace vtein
        btfss   stat, nula      ; sec = 60? (Z=1?)
        goto    real_b          ; ne  => pokraujeme
        movlw   min             
        movwf   fsr             ; ano => vbr minut
        call    aktual          ; aktualizace minut
        btfss   stat, nula      ; min = 60? (Z=1?)
        goto    real_b          ; ne  => pokraujeme
        movlw   hod
        movwf   fsr
        movlw   24h
        movwf   konec           ; ano => vbr hodin
        call    aktual          ; aktualizace hodin
real_b  call    tlacit          ; voln rutiny na zpracovn tlatek
        btfsc   stav1, test     ; testovac reim? (bit test=1?)
        goto    testr           ; ano => testovac reim
        call    zobraz          ; zobrazen asu
        call    _5ms            ; ekej 5ms
        goto    real_a          ; a pod dokola
;***************************************************************************
; Rutina testuje stav tlatek 6 a 7, kadm stiskem tlatka 6 se rozvt
; postupn jeden ze segment vech slicovek a diod D1 a D8, stisknutm
; tlatka 7 ukonme testovac reim a vrtme se do reimu relnho asu.
; Hodiny se bhem testovn chovaj stejn, jako by testovn nebylo, to je
; bu b nebo stoj podle bitu stop. Pro sprvnou funkci je teba propojku
; P1 propojit C0-AN5. K postupnmu rozsvcovn se pouvaj registry diody
; a anody. Registr diody se posl na port B a kadm stiskem tlatka nebo
; prbhem autorepeatu se v nm posouv nula, m se docl postupnho roz-
; svtcovn buzench diod. Registr diody tedy zabezpeuje buzen katod. Bu-
; zen anod zabepeuje registr anody, kter obsahuje postupn hodnoty:
; 1111, 0111, 1011, 1101, 1110 a cyklicky dle. Peklopen hodnot nastane
; vdy po prbhu nuly celm registrem diody. Registr anody se pole cel na
; port A a v je-li roven 1111, aktivuje se pin C0. Tm je zabezpeeno buzen
; spolen anody bu jedn slicovky nebo diod D1 a D8. Aby nedochzelo
; k peklpn hodnot, nejsou-li stisknuta dn tlatka a diody = 0ffh,
; je zaveden bit zmena, kterm se zmna povoluje. Jakmile je jednou zmna
; provedena, bit se shod a nastav se teprve a diody <> 0ffh.
; Poznmka: port C nen implementovn, tedy aktivace pinu C0 probhne pouze
; jako instrukce. Diody D1 a D8 nebudou tedy svtit, propojme-li propojku
; P1 +5V-AN5, pestanou fungovat tlatka, nebo se pes tyto diody vnut
; na sbrnici nesprvn rovn. Jedin monost vyzkouen diod je propojit
; propojku P1 AN3-AN5, pak budou tyto diody svtit souasn s slicovkou
; DISP3.
testr   movlw   b'11111111'
        movwf   porta           ; odpojen anod displeje
        movwf   portb           ; odpojen segment disleje a katod D1 a D8
        movwf   diody           ; kd do registru diody
        movlw   b'00001111'
        movwf   anody           ; poten hodnota do registru anody
        bcf     stav1, push     ; tlatko putno, bit shozen
        bcf     stav1, ah       ; nebude autorepeat hodin
        bcf     stav1, am       ; ani autorepeat minut
        bsf     stav1, zmena    ; zmna povolena
        clrf    cit_a           ; nulovn tae autorepeatu
test_a  decfsz  citac, f        ; uplynula 1s?
        goto    test_b          ; ne  => jdeme dle
        movlw   .200
        movwf   citac           ; ano => znovunastaven tae
        btfsc   stav1, stop     ; hodiny b? (bit stop=0?)
        goto    test_b          ; ne  => jdeme dle
        movlw   sec             ; ano => aktualizujeme as
        movwf   fsr
        movlw   60h
        movwf   konec           ; vbr vtein
        call    aktual          ; aktualizace vtein
        btfss   stat, nula      ; sec = 60? (Z=1?)
        goto    test_b          ; ne  => pokraujeme
        movlw   min             
        movwf   fsr             ; ano => vbr minut
        call    aktual          ; aktualizace minut
        btfss   stat, nula      ; min = 60? (Z=1?)
        goto    test_b          ; ne  => pokraujeme
        movlw   hod
        movwf   fsr
        movlw   24h
        movwf   konec           ; ano => vbr hodin
        call    aktual          ; aktualizace hodin
test_b  call    tltest          ; voln rutiny na zpracovn tlatek
        btfss   stav1, test     ; testovac reim? (bit test=1?)
        goto    real_a          ; ne  => reln as beze zmny registru citac
        ; bcf     portc, 0        ; odpojen anod diod D1 a D8
        movlw   b'11111111'
        movwf   porta           ; odpojen anod displeje
        movf    diody, w
        movwf   portb           ; kd diod nebo segment na port B
        movlw   0ffh
        xorwf   diody, w        
        btfss   stat, nula      ; diody = 0ffh? (Z=1?)
        goto    test_c          ; ne  => pouijeme stejnou hodnotu
                                ; ano => generace dal hodnoty registru
                                ;        anody v zvislosti na stavu bitu
                                ;        zmna
        btfss   stav1, zmena    ; meme generovat? (bit zmena = 1?)
        goto    test_c          ; ne  => pouijeme stejnou hodnotu
                                ; ano => generujeme dal hodnotu
        bcf     stav1, zmena    ; zmna zakzna
        movlw   0fh
        xorwf   anody, w        
        bsf     stat, carry     ; nastaven carry pro rotaci pedem
        btfsc   stat, nula      ; anody = 0fh? (Z=1?)
        bcf     stat, carry     ; ano => carry = 0
                                ; ne  => carry = 1 (odminula)
        swapf   anody, f        ; pehozen nibl
        rrf     anody, f        ; dal hodnota
        swapf   anody, f        ; vrcen zpt
        movlw   0fh
        andwf   anody, f        ; zamaskovn
test_c  movf    anody, w
        movwf   porta           ; aktivace spolen anody jedn slicovky
        xorlw   0fh
        btfsc   stat, nula      ; anody = 0fh (Z=1?)
      ;  bsf     portc, 0        ; ano => aktivace anod diod D1 a D8
                                ; ne  => svt jedna z slicovek, diody D1
                                ;        a D8 nechm zhasnuty
        incf    cit_m, f        ; inkrementujeme cit_m
        movlw   b'00000011'
        andwf   cit_m, f        ; zamaskovn, cit_m te t jen do 3
        call    _5ms            ; ekej 5ms
        goto    test_a          ; a pod dokola
;***************************************************************************
        end
